/*
@C:\WEB_649\SQL\END_CONV\ORACLE\5212_DFESTPO_CONFIRMACAO_AUTOMATICA_NF.SQL


 Descrio:
 Procedure relacionamento das AF's ao arquivo XML

 Criao:
 07/2023 - Lucas Primo dos Santos

 RAISE_APPLICATION_ERROR(-20501, '' , TRUE);
*/

CREATE OR REPLACE PROCEDURE CONFIRMACAO_AUTOMATICA_NF(P_NRACESSONFE IN VARCHAR2 DEFAULT 'N',
                                                      P_DTENTRADA IN DATE DEFAULT NULL
                                                      )
AS
   V_NRDIASGERAL  NUMBER;
   V_EXISTEFILI   NUMBER;
   V_ESTOQAPROV   VARCHAR2(01);
   V_LANCTOESTOQ  VARCHAR2(20);
   V_DTINICIAL    DATE;
   V_DTFINAL      DATE;
   V_SEQHIST      VARCHAR2(20);
   V_DTENTRSAID   DATE;
   V_NRACESSONFE  VARCHAR2(44);
BEGIN
   V_NRDIASGERAL := NULL;
   V_EXISTEFILI  := 0;
   BEGIN
      SELECT MAX(NRDIASCONFNF)
        INTO V_NRDIASGERAL
        FROM GERPARAMGERAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_NRDIASGERAL := NULL;
   END;

   IF (V_NRDIASGERAL IS NULL) THEN
      BEGIN
         SELECT COUNT(CDFILIAL)
           INTO V_EXISTEFILI
           FROM PARAMFILIAL
          WHERE NRDIASCONFNFFIL IS NOT NULL ;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_EXISTEFILI := 0;
      END;
   END IF;

   BEGIN
      SELECT NVL(MAX(IDPERLANESTAPNF), 'N')
        INTO V_ESTOQAPROV
        FROM PARAMGERAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_ESTOQAPROV := 'N';
   END;

   V_DTENTRSAID := P_DTENTRADA;
   IF ((P_NRACESSONFE IS NULL) OR (P_NRACESSONFE = 'N')) THEN
      V_NRACESSONFE := 'N';
   ELSE
      V_NRACESSONFE := P_NRACESSONFE;
   END IF;

   IF (V_NRACESSONFE = 'N') THEN
      IF (V_NRDIASGERAL IS NOT NULL) THEN /*Caso tenha informao cadastrada na pgina geral*/

         FOR C_NOTAS IN(SELECT N.CDFILIAL,   N.NRLANCTONF, N.NRACESSONFE, P.DTPROCESSA,
                               N.CDFILIRECE, N.CDTIPOOPER, N.VRPRODUTOS,  N.CDINSCESTA,
                               N.CDEMPRESA,  N.CDFORNECED
                          FROM NOTAFISCAL N, PARAMFILIAL P
                         WHERE (N.DTEMISSAO <= (P.DTPROCESSA - NVL(P.NRDIASCONFNFFIL, V_NRDIASGERAL)))
                           AND (N.DTEMISSAO <= P.DTPROCESSA)
                           AND (N.IDSTATUS = 'L')
                           AND (N.IDENTRSAIDOP = 'E')
                           AND (P.CDFILIAL = N.CDFILIRECE)) LOOP
            UPDATE NOTAFISCAL
               SET IDSTATUS     = 'P',
                   DTENTRSAID   = C_NOTAS.DTPROCESSA
             WHERE NRACESSONFE  = C_NOTAS.NRACESSONFE
               AND IDENTRSAIDOP = 'E';

            UPDATE INTG_NOTAFISCAL
               SET IDSTATUS     = 'U'
             WHERE NRACESSONFE  = C_NOTAS.NRACESSONFE;

            UPDATE NOTADESTINADA
               SET CDFILIAL    = C_NOTAS.CDFILIAL,
                   NRLANCTONF  = C_NOTAS.NRLANCTONF,
                   CDINSCESTA  = C_NOTAS.CDINSCESTA
             WHERE NRACESSONFE = C_NOTAS.NRACESSONFE;

            IF (V_ESTOQAPROV = 'N') THEN
               SELECT MAX(NRLANCESTQ)
                 INTO V_LANCTOESTOQ
                 FROM LANCTOESTOQ
                WHERE CDFILIAL   = C_NOTAS.CDFILIAL
                  AND NRLANCTONF = C_NOTAS.NRLANCTONF;

               IF (V_LANCTOESTOQ IS NOT NULL) THEN
                  FOR C_ITLANCTOEST IN (SELECT CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,
                                               NRSUBLOTE,    CDPRODMOVI,   DTLANCMOVI
                                          FROM ITLANCTOEST
                                         WHERE CDFILIAL   = C_NOTAS.CDFILIAL
                                           AND NRLANCESTQ = V_LANCTOESTOQ) LOOP

                     DELETE CUSTOCMPPROD
                      WHERE CDFILLANCEST = C_NOTAS.CDFILIAL
                        AND CDALMOXARIFE = C_ITLANCTOEST.CDALMOXARIFE
                        AND CDLOCALESTOQ = C_ITLANCTOEST.CDLOCALESTOQ
                        AND NRLOTEESTQ   = C_ITLANCTOEST.NRLOTEESTQ
                        AND NRSUBLOTE    = C_ITLANCTOEST.NRSUBLOTE
                        AND CDPRODUTO    = C_ITLANCTOEST.CDPRODMOVI
                        AND DTCUSTCMPPRO = C_ITLANCTOEST.DTLANCMOVI
                        AND NRLANCESTQ   = V_LANCTOESTOQ;
                  END LOOP;
               END IF;

               UPDATE LANCTOESTOQ
                  SET DTLANCESTQ   = C_NOTAS.DTPROCESSA
                WHERE CDFILIAL     = C_NOTAS.CDFILIAL
                  AND NRLANCESTQ   = V_LANCTOESTOQ;

               UPDATE ITLANCTOEST
                  SET IDEVOLESTOQ  = 'S',
                      DTLANCMOVI   = C_NOTAS.DTPROCESSA
                WHERE CDFILIAL     = C_NOTAS.CDFILIAL
                  AND NRLANCESTQ   = V_LANCTOESTOQ;

               IF C_NOTAS.DTPROCESSA < TRUNC(SYSDATE) THEN
                  V_DTINICIAL := C_NOTAS.DTPROCESSA;
               ELSE
                  V_DTINICIAL := TRUNC(SYSDATE);
               END IF;

               IF C_NOTAS.DTPROCESSA > TRUNC(SYSDATE) THEN
                  V_DTFINAL := C_NOTAS.DTPROCESSA;
               ELSE
                  V_DTFINAL := TRUNC(SYSDATE);
               END IF;

               CUSTO_LIQUIDO(C_NOTAS.CDFILIAL, V_LANCTOESTOQ, C_NOTAS.VRPRODUTOS);
               ATUALIZA_ESTOQUE(C_NOTAS.CDFILIRECE, V_DTINICIAL, V_DTFINAL, C_NOTAS.CDFILIAL, V_LANCTOESTOQ);
            END IF;

            V_SEQHIST := NULL;
            SELECT LPAD(TO_CHAR(TO_NUMBER(NVL(MAX(NRSEQHISTOR),0)) + 1), 20,'0') AS NRSEQHISTOR
              INTO V_SEQHIST
              FROM HISTXMLNFE
             WHERE NRACESSONFE = C_NOTAS.NRACESSONFE;

             INSERT INTO HISTXMLNFE(NRACESSONFE, NRSEQHISTOR, DTHISTORICO, IDTIPOOPER,
                          IDSTATUS, NRPROTOCOLONFE, DSOPERACAO, CDFILIAL,
                          NRLANCTONF, CDOPERADOR)
             VALUES (C_NOTAS.NRACESSONFE, V_SEQHIST, SYSDATE, '2',
                     'S', '', 'Confirmao automtica de NF', C_NOTAS.CDFILIAL,
                     C_NOTAS.NRLANCTONF, '');


            COMMIT;
         END LOOP;
      ELSE
         IF (V_EXISTEFILI > 0) THEN /*Caso no tenha informao cadastrada na pgina geral mas tenha para alguma filial*/
            FOR C_NOTAS IN(SELECT N.CDFILIAL,   N.NRLANCTONF, N.NRACESSONFE, P.DTPROCESSA,
                                  N.CDFILIRECE, N.CDTIPOOPER, N.VRPRODUTOS,  N.CDINSCESTA,
                                  N.CDEMPRESA,  N.CDFORNECED
                             FROM NOTAFISCAL N, PARAMFILIAL P
                            WHERE (N.DTEMISSAO <= (P.DTPROCESSA - P.NRDIASCONFNFFIL))
                              AND (N.DTEMISSAO <= P.DTPROCESSA)
                              AND (N.IDSTATUS = 'L')
                              AND (N.IDENTRSAIDOP = 'E')
                              AND (P.CDFILIAL = N.CDFILIRECE)
                              AND (P.NRDIASCONFNFFIL IS NOT NULL)) LOOP

               UPDATE NOTAFISCAL
                  SET IDSTATUS     = 'P',
                      DTENTRSAID   = C_NOTAS.DTPROCESSA
                WHERE NRACESSONFE  = C_NOTAS.NRACESSONFE
                  AND IDENTRSAIDOP = 'E';

               UPDATE INTG_NOTAFISCAL
                  SET IDSTATUS     = 'U'
                WHERE NRACESSONFE  = C_NOTAS.NRACESSONFE;

               UPDATE NOTADESTINADA
                  SET CDFILIAL    = C_NOTAS.CDFILIAL,
                      NRLANCTONF  = C_NOTAS.NRLANCTONF,
                      CDINSCESTA  = C_NOTAS.CDINSCESTA
                WHERE NRACESSONFE = C_NOTAS.NRACESSONFE;

               IF (V_ESTOQAPROV = 'N') THEN
                  SELECT MAX(NRLANCESTQ)
                    INTO V_LANCTOESTOQ
                    FROM LANCTOESTOQ
                   WHERE CDFILIAL   = C_NOTAS.CDFILIAL
                     AND NRLANCTONF = C_NOTAS.NRLANCTONF;

                  IF (V_LANCTOESTOQ IS NOT NULL) THEN
                     FOR C_ITLANCTOEST IN (SELECT CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,
                                                  NRSUBLOTE,    CDPRODMOVI,   DTLANCMOVI
                                             FROM ITLANCTOEST
                                            WHERE CDFILIAL   = C_NOTAS.CDFILIAL
                                              AND NRLANCESTQ = V_LANCTOESTOQ) LOOP

                        DELETE CUSTOCMPPROD
                         WHERE CDFILLANCEST = C_NOTAS.CDFILIAL
                           AND CDALMOXARIFE = C_ITLANCTOEST.CDALMOXARIFE
                           AND CDLOCALESTOQ = C_ITLANCTOEST.CDLOCALESTOQ
                           AND NRLOTEESTQ   = C_ITLANCTOEST.NRLOTEESTQ
                           AND NRSUBLOTE    = C_ITLANCTOEST.NRSUBLOTE
                           AND CDPRODUTO    = C_ITLANCTOEST.CDPRODMOVI
                           AND DTCUSTCMPPRO = C_ITLANCTOEST.DTLANCMOVI
                           AND NRLANCESTQ   = V_LANCTOESTOQ;
                     END LOOP;
                  END IF;

                  UPDATE LANCTOESTOQ
                     SET DTLANCESTQ   = C_NOTAS.DTPROCESSA
                   WHERE CDFILIAL     = C_NOTAS.CDFILIAL
                     AND NRLANCESTQ   = V_LANCTOESTOQ;

                  UPDATE ITLANCTOEST
                     SET IDEVOLESTOQ  = 'S',
                         DTLANCMOVI   = C_NOTAS.DTPROCESSA
                   WHERE CDFILIAL     = C_NOTAS.CDFILIAL
                     AND NRLANCESTQ   = V_LANCTOESTOQ;

                  IF (C_NOTAS.DTPROCESSA < TRUNC(SYSDATE)) THEN
                     V_DTINICIAL := C_NOTAS.DTPROCESSA;
                  ELSE
                     V_DTINICIAL := TRUNC(SYSDATE);
                  END IF;

                  IF (C_NOTAS.DTPROCESSA > TRUNC(SYSDATE)) THEN
                     V_DTFINAL := C_NOTAS.DTPROCESSA;
                  ELSE
                     V_DTFINAL := TRUNC(SYSDATE);
                  END IF;

                  CUSTO_LIQUIDO(C_NOTAS.CDFILIAL, V_LANCTOESTOQ, C_NOTAS.VRPRODUTOS);
                  ATUALIZA_ESTOQUE(C_NOTAS.CDFILIRECE, V_DTINICIAL, V_DTFINAL, C_NOTAS.CDFILIAL, V_LANCTOESTOQ);
               END IF;
               V_SEQHIST := NULL;
               SELECT LPAD(TO_CHAR(TO_NUMBER(NVL(MAX(NRSEQHISTOR),0)) + 1), 20,'0') AS NRSEQHISTOR
                 INTO V_SEQHIST
                 FROM HISTXMLNFE
                WHERE NRACESSONFE = C_NOTAS.NRACESSONFE;

                INSERT INTO HISTXMLNFE(NRACESSONFE, NRSEQHISTOR, DTHISTORICO, IDTIPOOPER,
                             IDSTATUS, NRPROTOCOLONFE, DSOPERACAO, CDFILIAL,
                             NRLANCTONF, CDOPERADOR)
                VALUES (C_NOTAS.NRACESSONFE, V_SEQHIST, SYSDATE, '2',
                        'S', '', 'Confirmao automtica de NF', C_NOTAS.CDFILIAL,
                        C_NOTAS.NRLANCTONF, '');
               COMMIT;
            END LOOP;
         END IF;
      END IF;
   ELSE
      IF (V_DTENTRSAID IS NULL) THEN
         V_DTENTRSAID := TRUNC(SYSDATE);
      END IF;
      FOR C_NOTAS IN(SELECT N.CDFILIAL,   N.NRLANCTONF, N.NRACESSONFE, P.DTPROCESSA,
                            N.CDFILIRECE, N.CDTIPOOPER, N.VRPRODUTOS,  N.CDINSCESTA,
                            N.CDEMPRESA,  N.CDFORNECED
                       FROM NOTAFISCAL N, PARAMFILIAL P
                      WHERE (N.DTEMISSAO <= V_DTENTRSAID)
                        AND (N.NRACESSONFE = V_NRACESSONFE)
                        AND (N.IDENTRSAIDOP = 'E')
                        AND (P.CDFILIAL = N.CDFILIRECE)) LOOP
         UPDATE NOTAFISCAL
            SET IDSTATUS     = 'P',
                DTENTRSAID   = V_DTENTRSAID
          WHERE NRACESSONFE  = C_NOTAS.NRACESSONFE
            AND IDENTRSAIDOP = 'E';

         UPDATE INTG_NOTAFISCAL
            SET IDSTATUS     = 'U'
          WHERE NRACESSONFE  = C_NOTAS.NRACESSONFE;

         UPDATE NOTADESTINADA
            SET CDFILIAL    = C_NOTAS.CDFILIAL,
                NRLANCTONF  = C_NOTAS.NRLANCTONF,
                CDINSCESTA  = C_NOTAS.CDINSCESTA
          WHERE NRACESSONFE = C_NOTAS.NRACESSONFE;

         IF (V_ESTOQAPROV = 'N') THEN
            SELECT MAX(NRLANCESTQ)
              INTO V_LANCTOESTOQ
              FROM LANCTOESTOQ
             WHERE CDFILIAL   = C_NOTAS.CDFILIAL
               AND NRLANCTONF = C_NOTAS.NRLANCTONF;

            IF (V_LANCTOESTOQ IS NOT NULL) THEN
               FOR C_ITLANCTOEST IN (SELECT CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,
                                            NRSUBLOTE,    CDPRODMOVI,   DTLANCMOVI
                                       FROM ITLANCTOEST
                                      WHERE CDFILIAL   = C_NOTAS.CDFILIAL
                                        AND NRLANCESTQ = V_LANCTOESTOQ) LOOP

                  DELETE CUSTOCMPPROD
                   WHERE CDFILLANCEST = C_NOTAS.CDFILIAL
                     AND CDALMOXARIFE = C_ITLANCTOEST.CDALMOXARIFE
                     AND CDLOCALESTOQ = C_ITLANCTOEST.CDLOCALESTOQ
                     AND NRLOTEESTQ   = C_ITLANCTOEST.NRLOTEESTQ
                     AND NRSUBLOTE    = C_ITLANCTOEST.NRSUBLOTE
                     AND CDPRODUTO    = C_ITLANCTOEST.CDPRODMOVI
                     AND DTCUSTCMPPRO = C_ITLANCTOEST.DTLANCMOVI
                     AND NRLANCESTQ   = V_LANCTOESTOQ;
               END LOOP;
            END IF;

            UPDATE LANCTOESTOQ
               SET DTLANCESTQ   = V_DTENTRSAID
             WHERE CDFILIAL     = C_NOTAS.CDFILIAL
               AND NRLANCESTQ   = V_LANCTOESTOQ;

            UPDATE ITLANCTOEST
               SET IDEVOLESTOQ  = 'S',
                   DTLANCMOVI   = C_NOTAS.DTPROCESSA
             WHERE CDFILIAL     = C_NOTAS.CDFILIAL
               AND NRLANCESTQ   = V_LANCTOESTOQ;

            IF (V_DTENTRSAID < TRUNC(SYSDATE)) THEN
               V_DTINICIAL := V_DTENTRSAID;
            ELSE
               V_DTINICIAL := TRUNC(SYSDATE);
            END IF;

            IF (V_DTENTRSAID > TRUNC(SYSDATE)) THEN
               V_DTFINAL := V_DTENTRSAID;
            ELSE
               V_DTFINAL := TRUNC(SYSDATE);
            END IF;

            CUSTO_LIQUIDO(C_NOTAS.CDFILIAL, V_LANCTOESTOQ, C_NOTAS.VRPRODUTOS);
            ATUALIZA_ESTOQUE(C_NOTAS.CDFILIRECE, V_DTINICIAL, V_DTFINAL, C_NOTAS.CDFILIAL, V_LANCTOESTOQ);
         END IF;

         DELETE
           FROM INTG_INCONSISTENCIA
          WHERE NRACESSONFE = V_NRACESSONFE;  

         V_SEQHIST := NULL;
         SELECT LPAD(TO_CHAR(TO_NUMBER(NVL(MAX(NRSEQHISTOR),0)) + 1), 20,'0') AS NRSEQHISTOR
           INTO V_SEQHIST
           FROM HISTXMLNFE
          WHERE NRACESSONFE = C_NOTAS.NRACESSONFE;

          INSERT INTO HISTXMLNFE(NRACESSONFE, NRSEQHISTOR, DTHISTORICO, IDTIPOOPER,
                       IDSTATUS, NRPROTOCOLONFE, DSOPERACAO, CDFILIAL,
                       NRLANCTONF, CDOPERADOR)
          VALUES (C_NOTAS.NRACESSONFE, V_SEQHIST, SYSDATE, '2',
                  'S', '', 'Confirmao NF Mobile', C_NOTAS.CDFILIAL,
                  C_NOTAS.NRLANCTONF, '');


         COMMIT;
      END LOOP;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CONFIRMACAO_AUTOMATICA_NF','6.49.044'); END;
/
