package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.Assert;

import java.time.temporal.Temporal;

public class ParametrosDePlanejamentoPage extends PageBase {

    By Inicio = By.xpath("//*[@class = 'navbar-brand zh-header-title has-header-info']");
    By clicaMenu = By.xpath("//*[@type = 'button']");
    By pesquisaTela = By.xpath("//section[@class = 'zh-container-search-menu']/input");
    By selecionaTela = By.xpath("//span[text() = 'Parâmetros de Planejamento']");
    By confirmaTela = By.xpath("//div[text() = 'Parâmetros de Planejamento']");
    By abaPersonalizacao = By.xpath("//span[text() = ' Personalização']");
    By btnEditar = By.xpath("//li[@data-zh-id='2439777433150567371275']");
    By utilizaTipoCardapio = By.xpath("//div[@class = 'zh-select-native-div']/div[2]");
    By opcaoPadronizado = By.xpath("//li[text() = 'Padronizado']");
    By opcaoLivre = By.xpath("//li[text() = 'Livre']");
    By opcaoDescentralizado = By.xpath("//li[text() = 'Que Depende de Liberação (Descentralizado)']");
    By filtroUnidadePadrao = By.xpath("//span[@zh-icon='no-border search']");
    By limpaUnidadePadrão = By.xpath("//span[@zh-icon= 'no-border close-x']");
    By abreFiltroBusca = By.xpath("//span[@class = 'action-icon search-action-icon zh-icon zh-icon-search zh-icon-no-border zh-icon-color-white']");
    By insereInformacao = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");
    By selecionaBusca = By.xpath("//div[@class = 'tr cell1']");
    By btnSalvar = By.xpath("//span[text() = 'Salvar']");
    By btnVoltar = By.xpath("//span[text() = 'Voltar']");

    //Aba Cardápio

    By abaCardapio = By.xpath("//span[text() = ' Cardápio']");
    By editarAbaCardapio = By.xpath("//li[@data-zh-id='2439777432013325810349']");
    By limpaCampoCarboidrato = By.xpath("//div[@id = 'NMCARBOHIDRA']//span[@zh-icon='no-border close-x']");
    By buscaCarboidrato = By.xpath("//div[@id = 'NMCARBOHIDRA']//span[@zh-icon='no-border search']");
    By clicaMenuFiltro = By.xpath("//div[@class = 'control-handle']");
    By limpaCampoAlcool = By.xpath("//div[@id = 'NMALCOOL']//span[@zh-icon='no-border close-x']");
    By buscaAlcool = By.xpath("//div[@id = 'NMALCOOL']//span[@zh-icon='no-border search']");
    By limpaCampoLipidio = By.xpath("//div[@id = 'NMLIPIDIOS']//span[@zh-icon='no-border close-x']");
    By buscaLipidio = By.xpath("//div[@id = 'NMLIPIDIOS']//span[@zh-icon='no-border search']");
    By limpaCampoAcidosGraxos = By.xpath("//div[@id = 'NMACIDGRAXOS']//span[@zh-icon='no-border close-x']");
    By buscaAcidoGraxos = By.xpath("//div[@id = 'NMACIDGRAXOS']//span[@zh-icon='no-border search']");
    By limpaCampoCaloria = By.xpath("//div[@id = 'NMCALORIAS']//span[@zh-icon='no-border close-x']");
    By buscaCaloria = By.xpath("//div[@id = 'NMCALORIAS']//span[@zh-icon='no-border search']");
    By limpaCampoSodio = By.xpath("//div[@id = 'NMSODIO']//span[@zh-icon='no-border close-x']");
    By buscaSodio = By.xpath("//div[@id = 'NMSODIO']//span[@zh-icon='no-border search']");
    By limpaCampoProteina = By.xpath("//div[@id = 'NMPROTEINA']//span[@zh-icon='no-border close-x']");
    By buscaProteina = By.xpath("//div[@id = 'NMPROTEINA']//span[@zh-icon='no-border search']");
    By limpaCampoProteinaVegetal = By.xpath("//div[@id = 'NMPROTVEGETA']//span[@zh-icon='no-border close-x']");
    By buscaProteinaVegetal = By.xpath("//div[@id = 'NMPROTVEGETA']//span[@zh-icon='no-border search']");
    By limpaCampoProteinaAnimal = By.xpath("//div[@id = 'NMPROTANIMAL']//span[@zh-icon='no-border close-x']");
    By buscaProteinaAnimal = By.xpath("//div[@id = 'NMPROTANIMAL']//span[@zh-icon='no-border search']");
    By limpaCampoAcucares = By.xpath("//div[@id = 'NMACUCARES']//span[@zh-icon='no-border close-x']");
    By buscaAcucares = By.xpath("//div[@id = 'NMACUCARES']//span[@zh-icon='no-border search']");
    By limpaCampoFibras = By.xpath("//div[@id = 'NMFIBRAS']//span[@zh-icon='no-border close-x']");
    By buscaFibras = By.xpath("//div[@id = 'NMFIBRAS']//span[@zh-icon='no-border search']");
    By limpaCampoGluten = By.xpath("//div[@id = 'NMGLUTEN']//span[@zh-icon='no-border close-x']");
    By buscaGluten = By.xpath("//div[@id = 'NMGLUTEN']//span[@zh-icon='no-border search']");
    By limpaCampoLactose = By.xpath("//div[@id = 'NMLACTOSE']//span[@zh-icon='no-border close-x']");
    By buscaLactose = By.xpath("//div[@id = 'NMLACTOSE']//span[@zh-icon='no-border search']");
    By checkBoxConsisteAtualizaEfetivos = By.xpath("//label[@for='zh-checkbox-IDCONSMINEFE']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By checkBoxObrigaInformarEfetivos = By.xpath("//label[@for='zh-checkbox-IDBLOQEFET']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By checkBoxLancaComensalSemPrato = By.xpath("//label[@for='zh-checkbox-IDPERCOMENSPRAT']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By checkBoxConsideraReceitaRevisada = By.xpath("//label[@for='zh-checkbox-IDRECREVICOP']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By checkBoxPermitePratoReceitaPadrao = By.xpath("//label[@for='zh-checkbox-IDUTRPADCA']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By diasBloqueioIncluseDtProcessamento = By.xpath("//input[@name = 'QTDIABLOQCAR']");
    By checkBoxBloqueiaInclusaoPratoLocal = By.xpath("//label[@for = 'zh-checkbox-IDBLOPRATLOC']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By checkBoxBloqueiaCodigoPratoPadraoIgualLocal = By.xpath("//label[@for = 'zh-checkbox-IDBLOQPRADUP']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By checkBoxBuscaPratoPorNome = By.xpath("//label[@for = 'zh-checkbox-IDPESQPRATNOME']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By checkBoxVisualizaComplementoProduto = By.xpath("//label[@for = 'zh-checkbox-IDPESQCOMPPROD']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By checkBoxMantemCoresCardapio = By.xpath("//label[@for = 'zh-checkbox-IDMANCORCARDALT']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By buscaAgrupamentoProdutoRevisaoReceita = By.xpath("//div[@class = 'zh-select-multiple zh-select-autocomplete mousetrap zh-field-NMGRUPPROD zh-text-align-left']/span");
    By limpaAgrupamentoProdutoRevisaoReceita = By.xpath("//div[@class = 'zh-select-multiple zh-select-autocomplete mousetrap zh-field-NMGRUPPROD zh-text-align-left']//span[@zh-icon='no-border close-x']");
    By qtdMesesHistoricoAjusteCardapio = By.xpath("//*[@id = 'NRMESHISTCARD']");

    //Aba Cálculo do NDPCAL
    By abaCalculoNdpcal = By.xpath("//span[text() = ' Cálculo do NDPCAL']");
    By btnAdicionar = By.xpath("//li[@data-zh-id='2439777434284754287380']");
    By buscaProduto = By.xpath("//span[@zh-icon='no-border search']");
    By clicaFatorCalculo = By.xpath("//div[@class = 'editable-content']");
    By insereFatorCalculo = By.xpath("//input[@id = 'VRFATCALNDPC']");
    By atualizaFatorCalculo = By.xpath("//*[@id='grid-2439777434170190933367']/div[2]/div/div/div[4]/div/input");
    By apagarProdutoNdpcal = By.xpath("//div[@class = 'td left-grid-actions fixed']");
    By confirmaExclusao = By.xpath("//button[@class = 'zh-alert-button horizontal']//span[text() = 'Sim']");
    By validaExclusao = By.xpath("//p[text() = 'Não há registros']");
    By btnOk = By.xpath("//button[@class = 'zh-alert-button']");
    By btnCancelar = By.xpath("//span[text() = 'Cancelar']");
    By clicarTela = By.xpath("//*[@class = 'body-content']");
    By btnSalvarAlteracoes = By.xpath("//*[text() = 'Salvar alterações']");

    public void acessarTela(){
        tempo();
        waitForElement(Inicio);
        tempo();
        click(clicaMenu);
        tempo();
        click(pesquisaTela);
        clearAndSendKeys(pesquisaTela,"Parâmetros de Planejamento");
        tempo();
        click(selecionaTela);
        tempo();
        tempo();
    }

    public String validaAcessoTela(){
        return getText(confirmaTela);
    }

    public void editaPersonalizacao(){
        tempo();
        click(abaPersonalizacao);
        tempo();
        click(btnEditar);
        tempo();
        click(utilizaTipoCardapio);
        tempo();
        click(opcaoPadronizado);
        tempo();
        click(filtroUnidadePadrao);
        tempo();
        click(abreFiltroBusca);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"0002");
        tempo();
        click(selecionaBusca);
        tempo();
        click(btnSalvar);
        tempo();
        click(btnEditar);
        tempo();
        click(limpaUnidadePadrão);
        tempo();
        click(utilizaTipoCardapio);
        tempo();
        click(opcaoDescentralizado);
        tempo();
        click(btnSalvar);
        tempo();
        click(btnEditar);
        tempo();
        click(utilizaTipoCardapio);
        click(opcaoLivre);
        click(btnSalvar);
        tempo();
        click(btnVoltar);
    }

    public void editarAbaCardapio(){
        tempo();
        click(abaCardapio);
        tempo();
        click(editarAbaCardapio);
        tempo();
        click(limpaCampoCarboidrato);
        click(limpaCampoAlcool);
        click(limpaCampoLipidio);
        click(limpaCampoAcidosGraxos);
        click(limpaCampoCaloria);
        click(limpaCampoSodio);
        click(limpaCampoProteina);
        click(limpaCampoProteinaVegetal);
        click(limpaCampoProteinaAnimal);
        click(limpaCampoAcucares);
        click(limpaCampoFibras);
        click(btnSalvar);
        tempo();
        click(editarAbaCardapio);
        tempo();
        click(buscaCarboidrato);
        tempo();
        click(abreFiltroBusca);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"019");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaAlcool);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"011");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaLipidio);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"006");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaAcidoGraxos);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"007");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaCaloria);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"010");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaSodio);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"003");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaProteina);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"021");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaProteinaVegetal);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"001");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaProteinaAnimal);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"018");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaAcucares);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"002");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaFibras);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"015");
        tempo();
        click(selecionaBusca);
        tempo();
        click(btnSalvar);
        scrollParametrosPla();
        tempo();
        click(editarAbaCardapio);
        tempo();
        click(buscaGluten);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"15");
        tempo();
        click(selecionaBusca);
        click(buscaLactose);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"14");
        tempo();
        click(selecionaBusca);
        tempo();
        click(btnSalvar);
        tempo();
        click(editarAbaCardapio);
        tempo();
        click(limpaCampoGluten);
        click(limpaCampoLactose);
        click(btnSalvar);
        tempo();
        click(editarAbaCardapio);
        tempo();
        click(checkBoxConsisteAtualizaEfetivos);
        click(checkBoxObrigaInformarEfetivos);
        click(checkBoxLancaComensalSemPrato);
        click(checkBoxConsideraReceitaRevisada);
        click(checkBoxPermitePratoReceitaPadrao);
        tempo();
        click(diasBloqueioIncluseDtProcessamento);
        clearAndSendKeys(diasBloqueioIncluseDtProcessamento,"2");
        click(checkBoxBloqueiaInclusaoPratoLocal);
        click(checkBoxBloqueiaCodigoPratoPadraoIgualLocal);
        click(checkBoxBuscaPratoPorNome);
        click(checkBoxVisualizaComplementoProduto);
        click(checkBoxMantemCoresCardapio);
        tempo();
        click(buscaAgrupamentoProdutoRevisaoReceita);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"0000000001");
        tempo();
        click(selecionaBusca);
        tempo();
        click(qtdMesesHistoricoAjusteCardapio);
        clearAndSendKeys(qtdMesesHistoricoAjusteCardapio,"3");
        tempo();
        click(btnSalvar);
        tempo();
        click(editarAbaCardapio);
        tempo();
        click(limpaAgrupamentoProdutoRevisaoReceita);
        click(btnSalvar);
        scrollParametrosPla();
        scrollParametrosPla();
        scrollParametrosPla();
        click(btnVoltar);
    }

    public void calculoNdpcal(){
        tempo();
        click(abaCalculoNdpcal);
        tempo();
        for (int i = 0; i < 2; i++){
            click(btnAdicionar);
            tempo();
            click(buscaProduto);
            tempo();
            click(insereInformacao);
            clearAndSendKeys(insereInformacao, "REFEIÇÕES TRANSPORTADAS");
            tempo();
            click(selecionaBusca);
            tempo();
            click(insereFatorCalculo);
            clearAndSendKeys(insereFatorCalculo, "2");
            tempo();
            click(btnSalvar);
        }
        tempo();
        click(btnOk);
        tempo();
        click(btnCancelar);
        tempo();
        Assert.assertEquals("REFEIÇÕES TRANSPORTADAS","REFEIÇÕES TRANSPORTADAS");
        click(clicaFatorCalculo);
        clearAndSendKeys(atualizaFatorCalculo,"3");
        click(clicarTela);
        click(btnSalvarAlteracoes);
        tempo();
        Assert.assertEquals("REFEIÇÕES TRANSPORTADAS","REFEIÇÕES TRANSPORTADAS");
        tempo();
        click(apagarProdutoNdpcal);
        tempo();
        click(confirmaExclusao);
        tempo();

    }

    public String validarExclusao(){
        return getText(validaExclusao);
    }



}
